/*
 * Various long string constants
 */

/*
 * XML Namespaces
 */

#define SA_NS_CONTENTTYPES \
	"http://schemas.microsoft.com/metro/2005/02/content-types"
#define SA_NS_COREPROPERTIES \
	"http://schemas.microsoft.com/metro/2005/02/md/core-properties"
#define SA_NS_SIGNATURES \
	"http://schemas.microsoft.com/metro/2005/02/digsig"
#define SA_NS_RELATIONSHIPS \
	"http://schemas.microsoft.com/metro/2005/02/relationships"
#define SA_NS_VERSIONING \
	"http://schemas.microsoft.com/winfx/markup-compatibility/2005"

#define SA_NS_DISCARDCONTROL \
	"http://schemas.microsoft.com/metro/2005/02/rp/discard-control"
#define SA_NS_FIXEDDOCUMENT \
	"http://schemas.microsoft.com/metro/2005/02/rp"
#define SA_NS_FIXEDDOCUMENTSEQUENCE \
	"http://schemas.microsoft.com/metro/2005/02/rp"
#define SA_NS_FIXEDPAGE \
	"http://schemas.microsoft.com/metro/2005/02/rp"
#define SA_NS_PRINTSCHEMAFRAMEWORK \
	"http://schemas.microsoft.com/windows/2003/08/printing/printschemaframework"
#define SA_NS_PRINTSCHEMAKEYWORDS \
	"http://schemas.microsoft.com/windows/2003/08/printing/printschemakeywords"
#define SA_NS_RESOURCEDICTIONARY \
	"http://schemas.microsoft.com/metro/2005/02/rp/resourcedictionary-key"

/*
 * Content types
 */

#define SA_TYPE_COREPROPERTIES \
	"application/vnd.ms-metro.core-properties+xml"
#define SA_TYPE_CERTIFICATE \
	"application/vnd.ms-metro.ds-certificate"
#define SA_TYPE_ORIGIN \
	"application/vnd.ms-metro.ds-origin"
#define SA_TYPE_SIGNATURE \
	"application/vnd.ms-metro.ds-xmlsignature+xml"
#define SA_TYPE_RELATIONSHIPS \
	"application/vnd.ms-metro.relationships+xml"

#define SA_TYPE_FIXEDDOCUMENT \
	"application/vnd.ms-metro.rp-fixeddocument+xml"
#define SA_TYPE_FIXEDDOCUMENTSEQUENCE \
	"application/vnd.ms-metro.rp-fixeddocumentsequence+xml"
#define SA_TYPE_FIXEDPAGE \
	"application/vnd.ms-metro.rp-fixedpage+xml"
#define SA_TYPE_FONT \
	"application/vnd.ms-opentype"
#define SA_TYPE_OBFUSCATEDFONT \
	"application/vnd.ms-metro.obfuscated-opentype"
#define SA_TYPE_PRINTTICKET \
	"application/vnd.ms-printing.printticket+xml"
#define SA_TYPE_JPEGIMAGE \
	"image/jpeg"
#define SA_TYPE_PNGIMAGE \
	"image/png"
#define SA_TYPE_TIFFIMAGE \
	"image/tiff"

/*
 * Relationship types
 */

#define SA_REL_COREPROPERTIES \
	"http://schemas.microsoft.com/metro/2005/02/md/core-properties"
#define SA_REL_SIGNATURE \
	"http://schemas.microsoft.com/metro/2005/02/ds/signature"
#define SA_REL_CERTIFICATE \
	"http://schemas.microsoft.com/metro/2005/02/ds/certificate"
#define SA_REL_ORIGIN \
	"http://schemas.microsoft.com/metro/2005/02/ds/origin"
#define SA_REL_THUMBNAIL \
	"http://schemas.microsoft.com/metro/2005/02/md/thumbnail"

#define SA_REL_ANNOTATIONS \
	"http://schemas.microsoft.com/metro/2005/02/rp/annotations"
#define SA_REL_DISCARDCONTROL \
	"http://schemas.microsoft.com/metro/2005/02/rp/discard-control"
#define SA_REL_PRINTTICKET \
	"http://schemas.microsoft.com/metro/2005/02/rp/printticket"
#define SA_REL_FIXEDREPRESENTATION \
	"http://schemas.microsoft.com/metro/2005/02/rp/fixedrepresentation"
#define SA_REL_REQUIREDRESOURCE \
	"http://schemas.microsoft.com/metro/2005/02/rp/required-resource"
#define SA_REL_RESTRICTEDFONT \
	"http://schemas.microsoft.com/metro/2005/02/rp/restricted-font"

